#*************************************************************************
#
#   OpenOffice.org - a multi-platform office productivity suite
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.12 $
#
#   last change: $Author: hr $ $Date: 2006-04-19 15:12:12 $
#
#   The Contents of this file are made available subject to
#   the terms of GNU Lesser General Public License Version 2.1.
#
#
#     GNU Lesser General Public License Version 2.1
#     =============================================
#     Copyright 2005 by Sun Microsystems, Inc.
#     901 San Antonio Road, Palo Alto, CA 94303, USA
#
#     This library is free software; you can redistribute it and/or
#     modify it under the terms of the GNU Lesser General Public
#     License version 2.1, as published by the Free Software Foundation.
#
#     This library is distributed in the hope that it will be useful,
#     but WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#     Lesser General Public License for more details.
#
#     You should have received a copy of the GNU Lesser General Public
#     License along with this library; if not, write to the Free Software
#     Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#     MA  02111-1307  USA
#
#*************************************************************************
PRJ		= ..$/..$/..$/..
PRJNAME = wizards
TARGET  = wizards_common
PACKAGE = com$/sun$/star$/wizards

# --- Settings -----------------------------------------------------

.INCLUDE : settings.mk
#.INCLUDE :  $(PRJ)$/util$/makefile.pmk

JARFILES= unoil.jar jurt.jar ridl.jar juh.jar jut.jar java_uno.jar java_uno_accessbridge 

.IF "$(SYSTEM_XALAN)" == "YES"
XCLASSPATH!:=$(XCLASSPATH)$(PATH_SEPERATOR)$(XALAN_JAR)
.ELSE
JARFILES += xalan.jar
.ENDIF

.IF "$(SYSTEM_XERCES)" == "YES"
XCLASSPATH!:=$(XCLASSPATH)$(PATH_SEPERATOR)$(XERCES_JAR)
.ELSE
JARFILES += xercesImpl.jar
.ENDIF

.IF "$(SYSTEM_XML_APIS)" == "YES"
XCLASSPATH!:=$(XCLASSPATH)$(PATH_SEPERATOR)$(XML_APIS_JAR)
.ELSE
JARFILES += xml-apis.jar
.ENDIF

JARCLASSDIRS	=                                               \
    com$/sun$/star$/wizards$/common	       	 		\
    com$/sun$/star$/wizards$/db	       	 		\
    com$/sun$/star$/wizards$/ui	       	 		\
    com$/sun$/star$/wizards$/document     	 		\
    com$/sun$/star$/wizards$/text

JARTARGET	= commonwizards.jar

# --- Files --------------------------------------------------------

JAVAFILES=							\
    common$/Desktop.java	                		\
    common$/NumberFormatter.java                 		\
    common$/FileAccess.java                 		\
    common$/Helper.java                     		\
    common$/InvalidQueryException.java      		\
    common$/JavaTools.java                  		\
    common$/NoValidPathException.java       		\
    common$/Properties.java                 		\
    common$/Resource.java                   		\
    common$/SystemDialog.java				\
    common$/Configuration.java				\
    common$/ConfigNode.java					\
    common$/ConfigGroup.java				\
    common$/ConfigSet.java					\
    common$/XMLProvider.java				\
    common$/XMLHelper.java					\
    common$/Renderer.java					\
    common$/Indexable.java					\
    common$/TerminateWizardException.java			\
    common$/UCB.java					\
    db$/DBMetaData.java					\
    db$/CommandMetaData.java				\
    db$/QueryMetaData.java					\
    db$/BlindtextCreator.java				\
    db$/FieldColumn.java					\
    db$/CommandName.java					\
    db$/RecordParser.java					\
    db$/TypeInspector.java					\
    db$/ColumnPropertySet.java				\
    db$/RelationController.java				\
    db$/TableDescriptor.java				\
    db$/SQLQueryComposer.java				\
    ui$/event$/AbstractListener.java			\
    ui$/event$/CommonListener.java				\
    ui$/event$/DataAware.java				\
    ui$/event$/DataAwareFields.java				\
    ui$/event$/EventNames.java				\
    ui$/event$/ListModelBinder.java				\
    ui$/event$/MethodInvocation.java			\
    ui$/event$/RadioDataAware.java				\
    ui$/event$/SimpleDataAware.java				\
    ui$/event$/Task.java					\
    ui$/event$/TaskEvent.java				\
    ui$/event$/TaskListener.java				\
    ui$/event$/UnoDataAware.java				\
    ui$/AggregateComponent.java				\
    ui$/CommandFieldSelection.java				\
    ui$/ControlScroller.java				\
    ui$/DBLimitedFieldSelection.java			\
    ui$/DocumentPreview.java				\
    ui$/FilterComponent.java				\
    ui$/FieldSelection.java					\
    ui$/ImageList.java					\
    ui$/PathSelection.java					\
    ui$/PeerConfig.java					\
    ui$/SortingComponent.java				\
    ui$/TitlesComponent.java				\
    ui$/WizardDialog.java					\
    ui$/UIConsts.java					\
    ui$/UnoDialog.java					\
    ui$/UnoDialog2.java					\
    ui$/XCommandSelectionListener.java			\
    ui$/XFieldSelectionListener.java			\
    ui$/XPathSelectionListener.java				\
    ui$/XCompletion.java					\
    document$/Control.java					\
    document$/DatabaseControl.java				\
    document$/FormHandler.java				\
    document$/GridControl.java				\
    document$/OfficeDocument.java				\
    document$/Shape.java					\
    document$/TimeStampControl.java				\
    text$/TextDocument.java					\
    text$/TextFieldHandler.java				\
    text$/TextFrameHandler.java				\
    text$/TextSectionHandler.java				\
    text$/TextStyleHandler.java				\
    text$/TextTableHandler.java				\
    text$/ViewHandler.java


#JAVACLASSFILES = $(foreach,i,$(JAVAFILES) $(CLASSDIR)$/$(PACKAGE)$/$(i:s/.java/.class/))

# --- Targets ------------------------------------------------------

.INCLUDE :  target.mk
